/*----------------------------------------------------------------------------*/
/*                                                                            */
/*    Module:       main.cpp                                                  */
/*    Author:       C:\Users\sashk                                            */
/*    Created:      Thu Sep 21 2023                                           */
/*    Description:  V5 project                                                */
/*                                                                            */
/*----------------------------------------------------------------------------*/

// ---- START VEXCODE CONFIGURED DEVICES ----
// Robot Configuration:
// [Name]               [Type]        [Port(s)]
// Controller1          controller                    
// ArmLift              motor         18              
// ClawLift             motor         8               
// rightbob             motor         14              
// rightdopmotor        motor         4               
// leftdopmotor         motor         3               
// Vision5              vision        5               
// visionmotor          motor29       H               
// culler               motor29       G               
// laser                motor29       F               
// ClawRotate           motor         16              
// right_motors         motor_group   1, 2            
// left_motor           motor_group   11, 12          
// Vision21             vision        21              
// leftbob              motor         17              
// ClawComrpes          motor         15              
// ---- END VEXCODE CONFIGURED DEVICES ----

#include "vex.h"
double k2 = 0.27;
double error;
bool autoLine = false;

using namespace vex;
void init(){
  rightbob.setStopping(hold);
  leftbob.setStopping(hold);
  ArmLift.setMaxTorque(10,percent);
  ClawLift.setMaxTorque(30,percent);
  ArmLift.spin(forward);
  ClawLift.spin(reverse);
  wait(400,msec);
  ArmLift.stop();
  ClawLift.stop();
  ArmLift.setPosition(600,degrees);
  ClawLift.setPosition(0,degrees);
  ArmLift.setMaxTorque(100,percent);
  ClawLift.setMaxTorque(100,percent);
  rightdopmotor.setStopping(brake);
}
int claw(){
  ClawComrpes.setStopping(hold);
    ClawComrpes.spin(forward);
    wait(1500,msec);
    ClawComrpes.setPosition(0,degrees);
    ClawComrpes.setVelocity(50,percent);
  while(true){
    if(Controller1.ButtonR1.pressing()){
    ClawComrpes.spinToPosition(-100,degrees);
    }
    else if(Controller1.ButtonR2.pressing()){
    ClawComrpes.spinToPosition(20,degrees);
    }
    else{
    ClawComrpes.stop();

      
    }
    wait(20,msec);
  }
}

int clawRot(){
  ClawRotate.setStopping(hold);
  ClawRotate.setVelocity(50,percent);
  ClawRotate.spin(forward);
  wait(1500,msec);
  ClawRotate.setPosition(0,degrees);
  ClawRotate.stop();
  while(true){
    if(Controller1.ButtonL1.pressing()){
      ClawRotate.spinToPosition(0,degrees);
      
    }
    else if(Controller1.ButtonL2.pressing()){
      ClawRotate.spinToPosition(-178,degrees);
    }
    else{
      ClawRotate.stop();
    }
    wait(20,msec);
  }
}


int linage(){
  while(Controller1.ButtonY.pressing()==false){
    Vision5.takeSnapshot(Vision5__SIG_1);
    error = Vision5.largestObject.centerX - 157.5;
    if (Vision5.largestObject.exists){
      left_motor.setVelocity(12+k2*error,percent);
      right_motors.setVelocity(12-k2*error,percent);
    }
    else{
      left_motor.setVelocity(16,percent);
      right_motors.setVelocity(16,percent);
    }
    left_motor.spin(reverse);
    right_motors.spin(reverse);
    wait(10,msec);
  }
  autoLine=false;
  return 0;
 
}


int teleOP(){
  double kp = 0.65;
  double perpendicular=0;
  double clawPerpendicular=0;
  double maxSpeed=25;

  ArmLift.setStopping(hold);
  ClawComrpes.spin(forward);
  wait(500,msec);
  ClawComrpes.setPosition(0,degrees);
  ClawComrpes.stop();

  culler.spin(forward);
  while (true){
    while(autoLine==true){
      wait(20,msec);
    }




  
  if (Controller1.ButtonDown.pressing()){
    
    rightbob.spin(forward);
    leftbob.spin(forward);
    }
    else if(Controller1.ButtonUp.pressing()){

      if(rightbob.position(degrees)<10){

      rightbob.setStopping(brake);
      rightbob.stop();
      leftbob.setStopping(brake);
      leftbob.stop();

    }
    else{
    rightbob.spin(reverse);
    leftbob.spin(reverse);

    }
    
    }
    else{
    rightbob.setStopping(hold);
    leftbob.setStopping(hold);
    rightbob.stop();
    leftbob.stop();


    if (Controller1.ButtonRight.pressing()){
    laser.spin(forward);
    }
    else if(Controller1.ButtonLeft.pressing()){
    laser.stop();
    }
    else{
    laser.stop();
    

    }

    if (Controller1.ButtonLeft.pressing()){
    visionmotor.spin(forward);
    }
    else if(Controller1.ButtonRight.pressing()){
    visionmotor.spin(reverse);
    }
    else{
    visionmotor.stop();

    }

  

  




    if(abs(Controller1.Axis2.position(percent))<7){
      ArmLift.setVelocity(0,percent);
      ArmLift.stop();
    }
    else if(ArmLift.position(degrees)>600 && Controller1.Axis2.position(percent)>=0){
    ArmLift.stop();
    }
    else if(ArmLift.position(degrees)<1 && Controller1.Axis2.position(percent)<=0){
    ArmLift.stop();
    }
    else{
      ArmLift.setVelocity(Controller1.Axis2.position(percent),percent);
      ArmLift.spin(forward);
    }

    if(ArmLift.position(degrees)<=470){
      if(ArmLift.position(degrees)<=205){
        clawPerpendicular=perpendicular;
      }
      else{
        clawPerpendicular=0;
      }
        if (kp*((500-clawPerpendicular-ArmLift.position(degrees))/3*2-ClawLift.position(degrees))>maxSpeed){
          ClawLift.setVelocity(maxSpeed,percent);
        }
        else if(kp*((500-clawPerpendicular-ArmLift.position(degrees))/3*2-ClawLift.position(degrees))<-maxSpeed){
          ClawLift.setVelocity(-maxSpeed,percent);
        }
        else{
          ClawLift.setVelocity(kp*((500-clawPerpendicular-ArmLift.position(degrees))/3*2-ClawLift.position(degrees)),percent); 
        }
      ClawLift.spin(forward); 
      }
    else{
      if (0.65*(200-ClawLift.position(degrees))>maxSpeed){
          ClawLift.setVelocity(maxSpeed,percent);
        }
        else if(0.65*(200-ClawLift.position(degrees))<-maxSpeed){
          ClawLift.setVelocity(-maxSpeed,percent);
        }
        else{
          ClawLift.setVelocity(0.65*(200-ClawLift.position(degrees)),percent);
        }
      ClawLift.spin(forward); 
    }
    if(Controller1.ButtonB.pressing()){
      perpendicular=200;
    }
    if(Controller1.ButtonA.pressing()){
      perpendicular=0;
    }
    



  rightdopmotor.setVelocity(Controller1.Axis3.position() - Controller1.Axis4.position(),percent);
  leftdopmotor.setVelocity(Controller1.Axis3.position() + Controller1.Axis4.position(),percent);
  rightdopmotor.spin(forward);
  leftdopmotor.spin(forward);
  if(rightbob.position(degrees)<30){
    leftdopmotor.stop();
    rightdopmotor.stop();
  }

  right_motors.setVelocity(Controller1.Axis3.position() + Controller1.Axis4.position(),percent);
      left_motor.setVelocity( Controller1.Axis3.position() - Controller1.Axis4.position(),percent);
      right_motors.spin(forward);
      left_motor.spin(forward);

    }  
  wait(20, msec);
  }
  return 0;
}






int main() {
  // Initializing Robot Configuration. DO NOT REMOVE!
  vexcodeInit();
  init();
  task rot(clawRot);
  task cl(claw); 
  task tel(teleOP);
  while(true){   
    // wait before repeating the process
    wait(20, msec);
  
   

  if (Controller1.ButtonX.pressing()){
    autoLine=true;
    linage();
  }

  
   
    wait(20,msec);
  }

  
}  

